Index: drivers/s390/block/dasd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -2298,225 +2744,387 @@
 		return -EINVAL;
 	}
 	major_info = device->major_info;
-#if 0
-	printk (KERN_DEBUG PRINTK_HEADER
-		"ioctl 0x%08x %s'0x%x'%d(%d) on /dev/%s (%d:%d,"
-		" devno 0x%04x on irq %d) with data %8lx\n",
-		no,
-		_IOC_DIR (no) == _IOC_NONE ? "0" :
-		_IOC_DIR (no) == _IOC_READ ? "r" :
-		_IOC_DIR (no) == _IOC_WRITE ? "w" :
-		_IOC_DIR (no) == (_IOC_READ | _IOC_WRITE) ? "rw" : "u",
-		_IOC_TYPE (no),
-                _IOC_NR (no),
-                _IOC_SIZE (no),
-		device->name, 
-                MAJOR (inp->i_rdev), 
-                MINOR (inp->i_rdev),
-		device->devinfo.devno, 
-                device->devinfo.irq, 
-                data);
-#endif
+
+	DBF_DEV_EVENT (DBF_DEBUG, device,
+                 "ioctl 0x%08x %s'0x%x'%d(%d) with data %8lx",
+                 no,
+                 (_IOC_DIR (no) == _IOC_NONE ? "0" :
+                  _IOC_DIR (no) == _IOC_READ ? "r" :
+                  _IOC_DIR (no) == _IOC_WRITE ? "w" :
+                  _IOC_DIR (no) == (_IOC_READ | _IOC_WRITE) ? "rw" : "u"),
+                 _IOC_TYPE (no),
+                 _IOC_NR (no),
+                 _IOC_SIZE (no),
+                 data);
+
 	switch (no) {
-        case DASDAPIVER: {
-			int ver = DASD_API_VERSION;
-			rc = put_user(ver, (int *) data);
-			break;
+        case DASDAPIVER: {      /* retrun dasd API version */
+                int ver = DASD_API_VERSION;
+                rc = put_user(ver, (int *) data);
+                break;
+        }
+	case BLKGETSIZE: {	/* Return device size in # of sectors */
+                long blocks = major_info->gendisk.sizes 
+                        [MINOR (inp->i_rdev)] << 1;
+                rc = put_user(blocks, (long *) data);
+                break;
+        }
+	case BLKGETSIZE64:{ 
+                u64 blocks = major_info->gendisk.sizes 
+                        [MINOR (inp->i_rdev)];
+                rc = put_user(blocks << 10, (u64 *) data);
+                break;
+        }
+	case BLKRRPART: {       /* reread partition table */
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+                rc = dasd_revalidate (device);
+                break;
         }
-	case BLKGETSIZE:{	/* Return device size */
-			long blocks = major_info->gendisk.sizes 
-                                      [MINOR (inp->i_rdev)] << 1;
-			rc = put_user(blocks, (long *) data);
-			break;
-		}
-	case BLKGETSIZE64:{
-			u64 blocks = major_info->gendisk.sizes 
-                                      [MINOR (inp->i_rdev)];
-			rc = put_user(blocks << 10, (u64 *) data);
-			break;
-		}
-	case BLKRRPART:{
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-			rc = dasd_revalidate (device);
-			break;
-		}
-	case HDIO_GETGEO:{
-			struct hd_geometry geo = { 0, };
-			rc = dasd_fillgeo (inp->i_rdev, &geo);
-			if (rc)
-				break;
+	case HDIO_GETGEO: {     /* return disk geometry */
+                struct hd_geometry geo = { 0, };
+                rc = dasd_fillgeo (inp->i_rdev, &geo);
+                if (rc)
+                        break;
 
-			rc = copy_to_user ((struct hd_geometry *) data, &geo,
-					   sizeof (struct hd_geometry));
-			if (rc)
-				rc = -EFAULT;
-			break;
-		}
-	case BIODASDDISABLE:{
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-                        if ( device->level > DASD_STATE_ACCEPT) {
-                                dasd_deactivate_queue(device);
-                                if ( device->request_queue)
-                                        dasd_flush_request_queues(device,0);
-                                dasd_flush_chanq(device,0);
-                                dasd_disable_blkdev(device);
-                                dasd_set_device_level (device->devinfo.devno, 
-                                                       device->discipline, 
-                                                       DASD_STATE_ACCEPT);
-                        }
+                rc = copy_to_user ((struct hd_geometry *) data, &geo,
+                                   sizeof (struct hd_geometry));
+                if (rc)
+                        rc = -EFAULT;
+                break;
+        }
+	case BIODASDDISABLE: {  /* disable device */
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
                         break;
+                }
+
+                if ( device->level > DASD_STATE_ACCEPT) {
+                        dasd_deactivate_queue(device);
+                        if ( device->request_queue)
+                                dasd_flush_request_queues(device,0);
+                        dasd_flush_chanq(device,0);
+                        dasd_disable_blkdev(device);
+                        dasd_set_device_level (device->devinfo.devno, 
+                                               device->discipline, 
+                                               DASD_STATE_ACCEPT);
+                }
+
+                break;
         }
-	case BIODASDENABLE:{
-                        dasd_range_t range = { 
-                                from: device->devinfo.devno,
-                                to: device->devinfo.devno 
-                        };
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-                        dasd_enable_ranges (&range, device->discipline, 0);
+	case BIODASDENABLE: {   /* enable device */
+                dasd_range_t range = { 
+                        from: device->devinfo.devno,
+                        to: device->devinfo.devno 
+                };
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
                         break;
+                }
+                dasd_enable_ranges (&range, device->discipline, 0);
+                break;
         }
-	case BIODASDFMT:{
-			/* fdata == NULL is no longer a valid arg to dasd_format ! */
-			int partn = MINOR (inp->i_rdev) &
-			    ((1 << major_info->gendisk.minor_shift) - 1);
-			format_data_t fdata;
+	case BIODASDFMT: {      /* format device */
+                /* fdata == NULL is no longer a valid arg to dasd_format ! */
+                int partn = MINOR (inp->i_rdev) &
+                        ((1 << major_info->gendisk.minor_shift) - 1);
+                format_data_t fdata;
+                
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+                if (dasd_features_from_devno(device->devinfo.devno)&DASD_FEATURE_READONLY) {
+                        rc = -EROFS;
+                        break;
+                }
+                if (!data) {
+                        rc = -EINVAL;
+                        break;
+                }
+                rc = copy_from_user (&fdata, (void *) data,
+                                     sizeof (format_data_t));
+                if (rc) {
+                        rc = -EFAULT;
+                        break;
+                }
+                if (partn != 0) {
 
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-                        if (dasd_features_from_devno(device->devinfo.devno)&DASD_FEATURE_READONLY) {
-                                rc = -EROFS;
-                                break;
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "Cannot low-level format a partition");
+
+                        return -EINVAL;
+                }
+                rc = dasd_format (device, &fdata);
+                break;
+        }
+	case BIODASDGATTR: {      /* Get Attributes (cache operations) */
+
+                attrib_data_t attrib;
+                
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+
+                if (!data) {
+                        rc = -EINVAL;
+                        break;
+                }
+                        
+                if (!device->discipline->get_attrib) {
+                        rc = -EINVAL;
+                        break;
+                }
+                        
+                device->discipline->get_attrib (device,
+                                                &attrib);
+                
+                rc = copy_to_user ((void *) data, &attrib,
+                                   sizeof (attrib_data_t));
+
+                if (rc) {
+                        rc = -EFAULT;
+                }
+
+                break;
+        }
+	case BIODASDSATTR: {      /* Set Attributes (cache operations) */
+
+                attrib_data_t attrib;
+                
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+
+                if (!data) {
+                        rc = -EINVAL;
+                        break;
+                }
+                        
+                if (!device->discipline->set_attrib) {
+                        rc = -EINVAL;
+                        break;
+                }
+                        
+                rc = copy_from_user (&attrib, (void *) data,
+                                     sizeof (attrib_data_t));
+                if (rc) {
+                        rc = -EFAULT;
+                        break;
+                }
+
+                rc = device->discipline->set_attrib (device,
+                                                     &attrib);
+                break;
+        }
+	case BIODASDPRRST: {    /* reset device profile information */
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+                memset (&device->profile, 0,
+                        sizeof (dasd_profile_info_t));
+                break;
+        }
+	case BIODASDPRRD: {     /* return device profile information */
+                rc = copy_to_user((long *)data,
+                                  (long *)&device->profile,
+                                  sizeof(dasd_profile_info_t));
+                if (rc)
+                        rc = -EFAULT;
+                break;
+        }
+	case BIODASDRSRV: {     /* reserve device */
+                ccw_req_t *cqr;
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+
+                if (!device->discipline->reserve) {
+                        rc = -EINVAL;
+                        break;
+                }
+                
+                cqr = device->discipline->reserve (device);
+
+                if (cqr) {
+                        struct timer_list res_timer;
+                        
+                        init_timer (&res_timer);
+                        res_timer.function = dasd_resrel_timeout; 
+                        res_timer.data     = (unsigned long) cqr;
+                        res_timer.expires  = jiffies + 2 * HZ; 
+                        add_timer (&res_timer);
+                        
+                        rc = dasd_sleep_on_immediate (cqr);
+
+                        del_timer_sync (&res_timer); 
+                        dasd_free_request (cqr, 
+                                           device);
+                } else {
+                        rc = -ENOMEM;
+                }
+                break;
+        }
+	case BIODASDRLSE: {     /* release device */
+                ccw_req_t *cqr;
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+
+                if (!device->discipline->release) {
+                        rc = -EINVAL;
+                        break;
+                }
+
+                cqr = device->discipline->release (device);
+                
+                if (cqr) {
+                        struct timer_list rel_timer;
+                        
+                        init_timer (&rel_timer);
+                        rel_timer.function = dasd_resrel_timeout; 
+                        rel_timer.data     = (unsigned long) cqr;
+                        rel_timer.expires  = jiffies + 2 * HZ; 
+                        add_timer (&rel_timer);
+                        
+                        rc = dasd_sleep_on_immediate (cqr);
+
+                        del_timer_sync (&rel_timer); /* in case of interrupt */
+                        dasd_free_request (cqr, 
+                                           device);
+                } else {
+                        rc = -ENOMEM;
+                }
+                break;
+        }
+	case BIODASDSLCK: {     /* steal lock - unconditional reserve device */
+                if (!capable (CAP_SYS_ADMIN)) {
+                        rc = -EACCES;
+                        break;
+                }
+                        
+                rc = dasd_steal_lock (device);
+                break;
+        }
+	case BIODASDINFO:       /* return dasd information */
+	case BIODASDINFO2: {    /* return dasd information2 (incl. format and features) */
+                dasd_information2_t dasd_info;
+                
+                unsigned long flags;
+
+                if (!device->discipline->fill_info) {
+                        rc = -EINVAL;
+                        break;
+                }
+
+                rc = device->discipline->fill_info (device, 
+                                                    &dasd_info);
+
+                dasd_info.label_block = device->sizes.pt_block;
+                dasd_info.devno = device->devinfo.devno;
+                dasd_info.schid = device->devinfo.irq;
+                dasd_info.cu_type = device->devinfo.sid_data.cu_type;
+                dasd_info.cu_model = device->devinfo.sid_data.cu_model;
+                dasd_info.dev_type = device->devinfo.sid_data.dev_type;
+                dasd_info.dev_model = device->devinfo.sid_data.dev_model;
+                dasd_info.open_count =
+                        atomic_read (&device->open_count);
+                dasd_info.status = device->level;
+                
+                /* check if device is really formatted - LDL / CDL was returned by 'fill_info' */
+                if ((device->level < DASD_STATE_READY) ||
+                    (dasd_check_bp_block (device)    )   ) {
+                        dasd_info.format = DASD_FORMAT_NONE;
+                }
+                
+                dasd_info.features = 
+                        dasd_features_from_devno (device->devinfo.devno);
+                
+                if (device->discipline) {
+                        memcpy (dasd_info.type,
+                                device->discipline->name, 4);
+                } else {
+                        memcpy (dasd_info.type, "none", 4);
+                }
+                dasd_info.req_queue_len = 0;
+                dasd_info.chanq_len = 0;
+
+                if ((device->request_queue            ) &&
+                    (device->request_queue->request_fn)   ) {
+                        struct list_head *l;
+                        ccw_req_t *cqr = device->queue.head;
+                        spin_lock_irqsave (&io_request_lock, flags);
+                        list_for_each (l,
+                                       &device->request_queue->
+                                       queue_head) {
+                                dasd_info.req_queue_len++;
                         }
-			if (!data) {
-				rc = -EINVAL;
-				break;
-			}
-			rc = copy_from_user (&fdata, (void *) data,
-					     sizeof (format_data_t));
-			if (rc) {
-				rc = -EFAULT;
-				break;
-			}
-			if (partn != 0) {
-				DASD_MESSAGE (KERN_WARNING, device, "%s",
-					      "Cannot low-level format a partition");
-				return -EINVAL;
-			}
-			rc = dasd_format (device, &fdata);
-			break;
-		}
-	case BIODASDPRRST:{     /* reset device profile information */
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-			memset (&device->profile, 0,
-				sizeof (dasd_profile_info_t));
-			break;
-		}
-	case BIODASDPRRD:{      /* retrun device profile information */
-			rc = copy_to_user((long *)data,
-					  (long *)&device->profile,
-					  sizeof(dasd_profile_info_t));
-			if (rc)
-				rc = -EFAULT;
-			break;
-		}
-	case BIODASDRSRV:{      /* reserve */
-			ccw_req_t *req;
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-			req = device->discipline->reserve (device);
-			rc = dasd_sleep_on_req (req);
-			dasd_free_request (req, device);
-			break;
-		}
-	case BIODASDRLSE:{      /* release */
-			ccw_req_t *req;
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-			req = device->discipline->release (device);
-			rc = dasd_sleep_on_req (req);
-			dasd_free_request (req, device);
-			break;
-		}
-	case BIODASDSLCK:{      /* steal lock - unconditional reserve */
-			ccw_req_t *req;
-			if (!capable (CAP_SYS_ADMIN)) {
-				rc = -EACCES;
-				break;
-			}
-			req = device->discipline->steal_lock (device);
-			rc = dasd_sleep_on_req (req);
-			dasd_free_request (req, device);
-			break;
-		}
-	case BIODASDINFO:{
-			dasd_information_t dasd_info;
-			unsigned long flags;
-			rc = device->discipline->fill_info (device, &dasd_info);
-                        dasd_info.label_block = device->sizes.pt_block;
-			dasd_info.devno = device->devinfo.devno;
-			dasd_info.schid = device->devinfo.irq;
-			dasd_info.cu_type = device->devinfo.sid_data.cu_type;
-			dasd_info.cu_model = device->devinfo.sid_data.cu_model;
-			dasd_info.dev_type = device->devinfo.sid_data.dev_type;
-			dasd_info.dev_model = device->devinfo.sid_data.dev_model;
-			dasd_info.open_count =
-			    atomic_read (&device->open_count);
-			dasd_info.status = device->level;
-			if (device->discipline) {
-				memcpy (dasd_info.type,
-					device->discipline->name, 4);
-			} else {
-				memcpy (dasd_info.type, "none", 4);
-			}
-			dasd_info.req_queue_len = 0;
-			dasd_info.chanq_len = 0;
-			if (device->request_queue->request_fn) {
-				struct list_head *l;
-				ccw_req_t *cqr = device->queue.head;
-				spin_lock_irqsave (&io_request_lock, flags);
-				list_for_each (l,
-					       &device->request_queue->
-					       queue_head) {
-					dasd_info.req_queue_len++;
-				}
-				spin_unlock_irqrestore (&io_request_lock,
-							flags);
-				s390irq_spin_lock_irqsave (device->devinfo.irq,
-							   flags);
-				while (cqr) {
-					cqr = cqr->next;
-					dasd_info.chanq_len++;
-				}
-				s390irq_spin_unlock_irqrestore (device->devinfo.
-								irq, flags);
-			}
-			rc =
-			    copy_to_user ((long *) data, (long *) &dasd_info,
-					  sizeof (dasd_information_t));
-			if (rc)
-				rc = -EFAULT;
-			break;
-		}
+                        spin_unlock_irqrestore (&io_request_lock,
+                                                flags);
+                        s390irq_spin_lock_irqsave (device->devinfo.irq,
+                                                   flags);
+                        while (cqr) {
+                                cqr = cqr->next;
+                                dasd_info.chanq_len++;
+                        }
+                        s390irq_spin_unlock_irqrestore (device->devinfo.
+                                                        irq, flags);
+                }
+
+                rc = copy_to_user ((long *) data, (long *) &dasd_info,
+                                   ((no == (unsigned int) BIODASDINFO2) ? 
+                                    sizeof (dasd_information2_t) : 
+                                    sizeof (dasd_information_t)));
+
+                if (rc)
+                        rc = -EFAULT;
+                break;
+        }
+        case BIODASDPSRD: { /* Performance Statistics Read */
+                
+                ccw_req_t              *cqr;
+                dasd_rssd_perf_stats_t *stats;
+
+                if ((!device->discipline->read_stats) ||
+                    (!device->discipline->ret_stats )   ) {
+                        rc = -EINVAL;
+                        break;
+                }
+
+                cqr = device->discipline->read_stats (device); 
+                
+                if (cqr) {
+                        
+                        if ((rc = dasd_sleep_on_req (cqr)) == 0) {
+                                
+                                if ((stats = device->discipline->ret_stats (cqr)) != NULL) {
+                                        
+                                        rc = copy_to_user ((long *) data,
+                                                           (long *) stats,
+                                                           sizeof (dasd_rssd_perf_stats_t));
+                                } else {
+                                        
+                                        rc = -EFAULT;
+                             }
+                        }
+                        
+                        dasd_free_request (cqr, 
+                                           device);
+                        
+                } else {
+                        rc = -ENOMEM;
+                }
+                break;
+        }
 #if 0 /* needed for XFS */
-	case BLKBSZSET:{
+	case BLKBSZSET: {
 		int bsz;
 		rc = copy_from_user ((long *)&bsz,(long *)data,sizeof(int));
 		if ( rc ) {
@@ -2528,10 +3136,46 @@
 				rc = -EINVAL; 
 		}
 		break;
-		}
+        }
 #endif /* 0 */
+	case BLKROSET: {
+                int intval;
+                dasd_range_t *temp;
+                int devindex = 0;
+                unsigned long flags;
+                struct list_head *l;
+                int major=MAJOR(device->kdev);
+                int minor;
+
+                if (!capable(CAP_SYS_ADMIN))
+                        return -EACCES;
+                if (inp->i_rdev != device->kdev)
+                        // ro setting is not allowed for partitions
+                        return -EINVAL; 
+                if (get_user(intval, (int *)(data)))
+                        return -EFAULT;
+                spin_lock_irqsave (&range_lock, flags);
+                list_for_each (l, &dasd_range_head.list) {
+                        temp = list_entry (l, dasd_range_t, list);
+                        if (device->devinfo.devno >= temp->from && device->devinfo.devno <= temp->to) {
+                                spin_unlock_irqrestore (&range_lock, flags);
+                                if (intval)
+                                        temp->features |= DASD_FEATURE_READONLY;
+                                else
+                                        temp->features &= ~DASD_FEATURE_READONLY;
+                                goto continue_blkroset;
+                        }
+                        devindex += temp->to - temp->from + 1;
+                }
+                spin_unlock_irqrestore (&range_lock, flags);
+                return(-ENODEV);
+continue_blkroset:
+                for (minor = MINOR(device->kdev); minor < MINOR(device->kdev) + (1 << DASD_PARTN_BITS); minor++)
+                        set_device_ro(MKDEV(major,minor), intval);
+                return 0;
+        }
+	case BLKBSZGET:
 	case BLKSSZGET:
-	case BLKROSET:
 	case BLKROGET:
 	case BLKRASET:
 	case BLKRAGET:
@@ -2541,37 +3185,41 @@
 	case BLKELVSET:
 		return blk_ioctl (inp->i_rdev, no, data);
 		break;
-	default:{
+	default: {
 
-			dasd_ioctl_list_t *old = dasd_find_ioctl (no);
-			if (old) {
-				if ( old->owner )
-					__MOD_INC_USE_COUNT(old->owner);
-				rc = old->handler (inp, no, data);
-				if ( old->owner )
-					__MOD_DEC_USE_COUNT(old->owner);
-			} else {
-				DASD_MESSAGE (KERN_INFO, device,
-					      "ioctl 0x%08x=%s'0x%x'%d(%d) data %8lx\n",
-					      no,
-					      _IOC_DIR (no) == _IOC_NONE ? "0" :
-					      _IOC_DIR (no) == _IOC_READ ? "r" :
-					      _IOC_DIR (no) == _IOC_WRITE ? "w" : 
-                                              _IOC_DIR (no) == 
-                                              (_IOC_READ | _IOC_WRITE) ? "rw" : "u",
-                                              _IOC_TYPE (no),
-					      _IOC_NR (no), 
-                                              _IOC_SIZE (no),
-					      data);
-				rc = -ENOTTY;
-			}
-			break;
+                dasd_ioctl_list_t *old = dasd_find_ioctl (no);
+                if (old) {
+                        if ( old->owner )
+                                __MOD_INC_USE_COUNT(old->owner);
+                        rc = old->handler (inp, no, data);
+                        if ( old->owner )
+                                __MOD_DEC_USE_COUNT(old->owner);
+                } else {
+
+                        DBF_DEV_EVENT (DBF_INFO, device,
+                                       "unknown ioctl 0x%08x=%s'0x%x'%d(%d) data %8lx",
+                                       no,
+                                       (_IOC_DIR (no) == _IOC_NONE ? "0" :
+                                        _IOC_DIR (no) == _IOC_READ ? "r" :
+                                        _IOC_DIR (no) == _IOC_WRITE ? "w" : 
+                                        _IOC_DIR (no) == 
+                                        (_IOC_READ | _IOC_WRITE) ? "rw" : "u"),
+                                       _IOC_TYPE (no),
+                                       _IOC_NR (no), 
+                                       _IOC_SIZE (no),
+                                       data);
+
+                        rc = -ENOTTY;
+                }
+                break;
 		}
 	}
 	return rc;
 }
 
-/* SECTION: The members of the struct file_operations */
+/********************************************************************************
+ * SECTION: The members of the struct file_operations 
+ ********************************************************************************/
 
 static int
 dasd_ioctl (struct inode *inp, struct file *filp,
@@ -2597,26 +3245,32 @@
                 goto fail;
 	}
 	if (dasd_probeonly) {
-		printk ("\n" KERN_INFO PRINTK_HEADER
-			"No access to device (%d:%d) due to probeonly mode\n",
-			MAJOR (inp->i_rdev), 
-                        MINOR (inp->i_rdev));
+
+		MESSAGE (KERN_INFO,
+                         "No access to device (%d:%d) due to probeonly mode",
+                         MAJOR (inp->i_rdev), 
+                         MINOR (inp->i_rdev));
+
 		rc = -EPERM;
                 goto fail;
 	}
         spin_lock_irqsave(&discipline_lock,flags);
 	device = dasd_device_from_kdev (inp->i_rdev);
 	if (!device) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"No device registered as (%d:%d)\n",
-			MAJOR (inp->i_rdev), 
-                        MINOR (inp->i_rdev));
+
+		MESSAGE (KERN_WARNING,
+                         "No device registered as (%d:%d)",
+                         MAJOR (inp->i_rdev), 
+                         MINOR (inp->i_rdev));
+
 		rc = -ENODEV;
                 goto unlock;
 	}
 	if (device->level <= DASD_STATE_ACCEPT ) {
-		DASD_MESSAGE (KERN_WARNING, device, " %s", 
-                              " Cannot open unrecognized device\n");
+
+		DBF_DEV_EVENT (DBF_ERR, device, " %s", 
+                               " Cannot open unrecognized device");
+
 		rc = -ENODEV;
                 goto unlock;
 	}
@@ -2648,17 +3302,21 @@
 	}
 	device = dasd_device_from_kdev (inp->i_rdev);
 	if (!device) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"No device registered as %d:%d\n",
-			MAJOR (inp->i_rdev), 
-                        MINOR (inp->i_rdev));
+
+		MESSAGE (KERN_WARNING,
+                         "No device registered as %d:%d",
+                         MAJOR (inp->i_rdev), 
+                         MINOR (inp->i_rdev));
+
 		rc = -EINVAL;
                 goto out;
 	}
 
 	if (device->level < DASD_STATE_ACCEPT ) {
-		DASD_MESSAGE (KERN_WARNING, device, " %s",
-                              " Cannot release unrecognized device\n");
+
+		DBF_DEV_EVENT (DBF_ERR, device, " %s",
+                               " Cannot release unrecognized device");
+
 		rc = -ENODEV;
                 goto out;
 	}
@@ -2669,8 +3327,9 @@
                         __MOD_DEC_USE_COUNT(device->discipline->owner);
 	} else if ( count == -1 ) { /* paranoia only */
                 atomic_set (&device->open_count,0);
-                printk (KERN_WARNING PRINTK_HEADER
-                        "release called with open count==0\n");
+
+                MESSAGE (KERN_WARNING, "%s",
+                         "release called with open count==0");
         }
  out:
 	return rc;
@@ -2685,7 +3344,9 @@
 	ioctl:dasd_ioctl,
 };
 
-/* SECTION: Management of device list */
+/********************************************************************************
+ * SECTION: Management of device list 
+ ********************************************************************************/
 int
 dasd_fillgeo(int kdev,struct hd_geometry *geo)
 {
@@ -2708,24 +3369,27 @@
 int
 dasd_device_name (char *str, int index, int partition, struct gendisk *hd)
 {
-	int len = 0;
+        major_info_t *major_info;
+        struct list_head *l;
 	char first, second, third;
+	int len;
 
-	if (hd) {
-		major_info_t *major_info = NULL;
-		struct list_head *l;
-
-		list_for_each (l, &dasd_major_info[0].list) {
-			major_info = list_entry (l, major_info_t, list);
-			if (&major_info->gendisk == hd) {
-				break;
-			}
-			index += DASD_PER_MAJOR;
-		}
-		if (major_info == &dasd_major_info[0]) {
-			return -EINVAL;
-		}
-	}
+        if (hd == NULL)
+                return -EINVAL;
+
+        major_info = NULL;
+        list_for_each (l, &dasd_major_info) {
+                major_info = list_entry (l, major_info_t, list);
+                if (&major_info->gendisk == hd)
+                        break;
+                index += DASD_PER_MAJOR;
+        }
+        if (major_info == NULL || &major_info->gendisk != hd) { 
+                /* list empty or hd not found in list */
+                return -EINVAL;
+        }
+
+        len = 0;
 	third = index % 26;
 	second = ((index - 26) / 26) % 26;
 	first = (((index - 702) / 26) / 26) % 26;
@@ -2773,11 +3437,12 @@
                 while ( cqr != NULL ) {
                         if ( cqr->status == CQR_STATUS_IN_IO )
                                 device->discipline->term_IO (cqr);
-                        if ( cqr->status != CQR_STATUS_DONE ||
+                        if ( cqr->status != CQR_STATUS_DONE &&
                              cqr->status != CQR_STATUS_FAILED ) {
 
                                 cqr->status = CQR_STATUS_FAILED;
-                                asm volatile ("STCK %0":"=m" (cqr->stopclk));
+
+                                cqr->stopclk = get_clock ();
 
                         }
                         dasd_schedule_bh(device);
